var currentWord = -1;
var doneWords = 0;
var randomOrder = true;
var languagePositions;

function loadPractice() {
	loadXMLDoc(docUrl,processChangePractice);
}

function processChangePractice() {
    if (req.readyState == 4) {
    	var strVal;
        if (req.status == 200) {
        	generateItems();
			document.title = rawGetElementTextNS("title", info[0], 0) + ": Practice";
			languagePositions = new Array();
			if (readCookie('practiceL' + languages[0]))
				languagePositions[0] = eval(readCookie('practiceL' + languages[0]));
			else
				languagePositions[0] = 0;
		    for (var i = 1; i < languages.length; i++) {
				if (readCookie('practiceL' + languages[i]))
					languagePositions[i] = eval(readCookie('practiceL' + languages[i]));
				else
					languagePositions[i] = 1;
			}
			var foundFront = false;
			var foundBack = false;
		    for (var i = 0; i < languages.length; i++) {
				if (languagePositions[i] == 0)
					foundFront = true;
				else if (languagePositions[i] == 1)
					foundBack = true;
			}
			if (!foundFront) {
				if (languagePositions[0] == 1)
					languagePositions[1] = 0;
				else
					languagePositions[0] = 0;
			}
			if (!foundBack) {
				if (languagePositions[0] == 0)
					languagePositions[1] = 1;
				else
					languagePositions[0] = 1;
			}
			if (readCookie('practiceRandom'))
				randomOrder = eval(readCookie('practiceRandom'));
			showPracticeSetup();
        } else {
       	 	div = document.getElementById("practice");
     	    div.innerHTML = "<tr><td>There was an error with the file:\n" + req.statusText+"</td></tr>";
        }
    }
}

function showPracticeSetup() {
	document.getElementById("random").checked = randomOrder;
	var strVal = "";
	var showDontShow = (languages.length > 2);
	for (var i = 0; i < languages.length; i++) {
		strVal += "<tr><td class='right'>" + languages[i] + ":</td><td><select id='L" + languages[i] + "' onchange='checkLanguages(" + i + ");'><option value='0'>Front Side</option><option value='1'>Back Side</option>"
		if (showDontShow)
			strVal += "<option value='-1'>Don't Show</option>";
		strVal += "</select></td></tr>";
	}
	div = document.getElementById("languages");
	div.innerHTML = strVal;
	
	for (var i = 0; i < languages.length; i++) {
		document.getElementById("L" + languages[i]).value = languagePositions[i];
	}
	
	document.getElementById("practice").className = "hidden";
	document.getElementById("setup").className = "visible";
	document.getElementById("finish").className = "hidden";
	setStyleByTag("a","color","rgb(" + rawGetElementTextNS("defaultColor", info[0], 0) + ")",1);
}

function startPractice() {
	words = new Array();
	for (var i = 0; i < allWords.length; i++) {
		words[i] = allWords[i];
	}
	randomOrder = document.getElementById("random").checked;
	for (var i = 0; i < languages.length; i++) {
		languagePositions[i] = document.getElementById("L" + languages[i]).value;
		createCookie('practiceL' + languages[i],languagePositions[i]);
	}
	createCookie('practiceRandom',randomOrder);	
	doneWords = 0;
	document.getElementById("cancel").className = "visible";
	showFront();
	findNextWord();
	showWord();
	hidePracticeSetup();
}

function hidePracticeSetup() {
	document.getElementById("practice").className = "visible";
	document.getElementById("setup").className = "hidden";
}

function findNextWord() {
	if (words.length < 2)
		currentWord = 0;
	else {
		if (randomOrder) {
			var lastWord = currentWord;
			while(lastWord == currentWord) {
				currentWord = Math.round((words.length-1)*Math.random());
			}
		} else {
			currentWord++;
			if (currentWord >= words.length)
				currentWord = 0;
		}
	}
	showWord();
}

function showWord() {
	var word = words[currentWord];
	var strVal = "";
	for (var i = 0; i < languages.length; i++) {
		if (languagePositions[i] == 0) {
			if (word["_color"] != null)
				strVal += "<tr style='color: rgb(" + word["_color"] + ");'><td class='language" + languages[i] + "'>" + textForLang(currentWord,i) + "</td></tr>";
			else
				strVal += "<tr><td class='language" + languages[i] + "'>" + textForLang(currentWord,i) + "</td></tr>";
			// change this to an unordered list?
		}
	}
	div = document.getElementById("front");
	div.innerHTML = strVal;
	var strVal = "";
	for (var i = 0; i < languages.length; i++) {
		if (languagePositions[i] == 1) {
			if (word["_color"] != null)
				strVal += "<tr style='color: rgb(" + word["_color"] + ");'><td class='language" + languages[i] + "'>" + textForLang(currentWord,i) + "</td></tr>";
			else
				strVal += "<tr><td class='language" + languages[i] + "'>" + textForLang(currentWord,i) + "</td></tr>";
		}
	}
	div = document.getElementById("back");
	div.innerHTML = strVal;
	div = document.getElementById("frontNum");
	if (words.length == 1)
		div.innerHTML = "1 word"
	else
		div.innerHTML = words.length + " words";
	div = document.getElementById("backNum");
	if (doneWords == 1)
		div.innerHTML = "1 word"
	else
		div.innerHTML = doneWords + " words";
}

function checkLanguages(lang) {
	var numFront = 0;
	var numBack = 0;
    for (var i = 0; i < languagePositions.length; i++) {
    	if (document.getElementById("L" + languages[i]).value == 0)
    		numFront++;
    	else if (document.getElementById("L" + languages[i]).value == 1)
    		numBack++;
	}
	if ((numFront != 0) && (numBack != 0))
		return;
	var target = lang + 1;
	if (target >= languagePositions.length)
		target = 0;
	while(document.getElementById("L" + languages[target]).value != -1) {
		target++;
		if (target >= languagePositions.length)
			target = 0;
		if (target == lang) {
			target++;
			if (target >= languagePositions.length)
				target = 0;
			break;
		}
	}
	if (numFront == 0)
		document.getElementById("L" + languages[target]).value = 0;
	else if (numBack == 0)
		document.getElementById("L" + languages[target]).value = 1;
}

function showFront() {
	document.getElementById("flip").className = "visible";
	document.getElementById("front").className = "visible";
	document.getElementById("back").className = "hidden";
	document.getElementById("left").className = "hidden";
	document.getElementById("right").className = "hidden";
}

function practiceFlip() {
	document.getElementById("flip").className = "hidden";
	document.getElementById("front").className = "ghost";
	document.getElementById("back").className = "visible";
	document.getElementById("left").className = "visible";
	document.getElementById("right").className = "visible";
}

function practiceLeft() {
	findNextWord();
	showFront();
}

function practiceRight() {
	words.splice(currentWord,1);
	doneWords++;
	if (randomOrder)
		currentWord = -1;
	else
		currentWord--;
	if (words.length == 0)
		finishPractice();
	else {
		findNextWord();
		showFront();
	}
}

function finishPractice() {
	document.getElementById("practice").className = "hidden";
	document.getElementById("finish").className = "visible";
	document.getElementById("cancel").className = "hidden";
}
